Bug 1297552 - Review Request: atomic-devmode - Try out Atomic Host without cloud-init
Review Request: atomic-devmode - Try out Atomic Host without cloud-init
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Patrick Uiterwijk
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2016-01-11 15:21 EST by Jonathan Lebon
Modified: 2016-07-13 13:27 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-07-13 13:27:53 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
puiterwijk: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Jonathan Lebon 2016-01-11 15:21:42 EST
Homepage: https://github.com/jlebon/atomic-devmode
Spec URL: https://jlebon.fedorapeople.org/atomic-devmode.spec
SRPM URL: https://jlebon.fedorapeople.org/atomic-devmode-0.1-1.fc23.src.rpm
Koji build: http://koji.fedoraproject.org/koji/taskinfo?taskID=12502182

Fedora Account System Username: jlebon

Description (from specfile):

---
This package installs a Developer Mode boot option useful    
for trying out an Atomic Host without having to set up a     
cloud-init source. When booted, the system automatically     
logs in and starts the Cockpit container.
---

More information on the motivation for this package can be found on the atomic-devel mailing list:

https://lists.projectatomic.io/projectatomic-archives/atomic-devel/2015-December/msg00034.html

This is my first package and thus, I need a sponsor. I am also the upstream maintainer for the project. Please let me know if I misfiled this, or if there's something else I should do to get the review process going.

Thanks!
Comment 1 Jonathan Lebon 2016-01-11 15:40:10 EST
To clarify some more: this package is mainly meant for integration with Atomic Hosts. Getting the package in the repo is the first step. Then the kickstart files will have to be modified so that the boot menu item is added in the default image.

If it will help, it should also be possible to make it compatible with the Cloud images, so that users would be able to do, e.g.:

$ sudo dnf install atomic-devmode
$ sudo /usr/libexec/atomic-devmode/atomic-devmode-install
$ sudo reboot

and then select "Developer Mode" in the GRUB 2 menu.

However, being able to do the above means that you were able to get into the system in the first place, which means that you already have cloud-init set up. :)

A more realistic alternate use case for supporting regular Cloud images would be e.g. someone who wants to build their own Cloud image which auto-logs in.
Comment 2 Roman Tsisyk 2016-01-12 03:28:24 EST
Sorry, I could not understand what is it.
Could you please start with the better Summary and %description.
Comment 3 Roland Grunberg 2016-01-12 09:35:17 EST
Hey Jonathan, I noticed the package is versioned as 0.1, but the upstream repo has no releases. This makes it difficult for someone to determine what was actually used as '%{name}.tar.gz'. Unless the link is an archive, you'd generally want to describe how the source archive was created (eg. commented shell commands one the line above).

If you don't wish to tag releases perhaps snapshot versioning [1] would make more sense.

[1] https://fedoraproject.org/wiki/Packaging:NamingGuidelines#Snapshot_packages
Comment 4 Jonathan Lebon 2016-01-12 10:32:50 EST
(In reply to Roman Tsisyk from comment #2)
> Sorry, I could not understand what is it.
> Could you please start with the better Summary and %description.

(In reply to Roland Grunberg from comment #3)
> Hey Jonathan, I noticed the package is versioned as 0.1, but the upstream
> repo has no releases. This makes it difficult for someone to determine what
> was actually used as '%{name}.tar.gz'. Unless the link is an archive, you'd
> generally want to describe how the source archive was created (eg. commented
> shell commands one the line above).

Thanks Roland. I tagged v0.1 upstream:

https://github.com/jlebon/atomic-devmode/releases/tag/v0.1

I also updated the specfile with a comment to explain how to create the archive:

---
# Produced by `make archive`
Source: %{name}.tar.gz
---

Let me know if that's still no good.
Comment 5 Jonathan Lebon 2016-01-12 10:35:38 EST
(In reply to Roman Tsisyk from comment #2)
> Sorry, I could not understand what is it.
> Could you please start with the better Summary and %description.

Hi Roman,

Does the description make more sense in the context of this post?

https://lists.projectatomic.io/projectatomic-archives/atomic-devel/2015-December/msg00034.html

I can rework it, but need to know which parts don't make sense (or is it all of it? :)).
Comment 6 Patrick Uiterwijk 2016-01-13 14:27:52 EST
I will take this review, and am a sponsor.
Comment 7 Patrick Uiterwijk 2016-01-13 16:20:09 EST
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
- License is a very old one (Library GPL, which is superseded by Lesser GPL)
- COPYING is not installed
- Using both %-style macros and $-style variables
- Package contains a lot of files that don't currenlty conflict, but sound
  like they will very likely conflict easily
- Hardcoded paths used (%_prefix}/lib vs %{_libdir})
- No %build section
- No documentation


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[-]: License field in the package spec file matches the actual license.
[-]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[!]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[!]: Package does not generate any conflict.
[!]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: SourceX tarball generation or download is documented.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: atomic-devmode-0.1-1.fc21.x86_64.rpm
          atomic-devmode-0.1-1.fc21.src.rpm
atomic-devmode.x86_64: E: explicit-lib-dependency libpwquality
atomic-devmode.x86_64: E: no-binary
atomic-devmode.x86_64: W: only-non-binary-in-usr-lib
atomic-devmode.x86_64: W: no-documentation
atomic-devmode.src: W: spelling-error %description -l en_US init -> unit, int, nit
atomic-devmode.src:32: E: hardcoded-library-path in %{_prefix}/lib/atomic-devmode
atomic-devmode.src: W: no-%build-section
atomic-devmode.src: W: invalid-url Source0: atomic-devmode.tar.gz
2 packages and 0 specfiles checked; 3 errors, 5 warnings.




Rpmlint (installed packages)
----------------------------
atomic-devmode.x86_64: E: explicit-lib-dependency libpwquality
atomic-devmode.x86_64: E: no-binary
atomic-devmode.x86_64: W: only-non-binary-in-usr-lib
atomic-devmode.x86_64: W: no-documentation
1 packages and 0 specfiles checked; 2 errors, 2 warnings.



Requires
--------
atomic-devmode (rpmlib, GLIBC filtered):
    /bin/bash
    atomic
    cloud-init
    grub2-tools
    libpwquality
    tmux



Provides
--------
atomic-devmode:
    atomic-devmode
    atomic-devmode(x86-64)



Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1297552
Buildroot used: fedora-21-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 8 Patrick Uiterwijk 2016-01-13 16:52:09 EST
Oh, and you should mark the package as noarch probably, since I odn't think there's anything archful in there.
Comment 9 Jonathan Lebon 2016-01-13 16:53:57 EST
(In reply to Patrick Uiterwijk from comment #8)
> Oh, and you should mark the package as noarch probably, since I odn't think
> there's anything archful in there.

Will do. Thanks for the review!
Comment 10 Upstream Release Monitoring 2016-01-14 15:41:49 EST
jlebon's scratch build of atomic-devmode-0.2-1.fc23.src.rpm for f23 completed http://koji.fedoraproject.org/koji/taskinfo?taskID=12550898
Comment 11 Jonathan Lebon 2016-01-14 15:46:54 EST
Updated:

Homepage: https://github.com/jlebon/atomic-devmode
Spec URL: https://jlebon.fedorapeople.org/atomic-devmode.spec
SRPM URL: https://jlebon.fedorapeople.org/atomic-devmode-0.2-1.fc23.src.rpm
Koji build: http://koji.fedoraproject.org/koji/taskinfo?taskID=12550898

---

(In reply to Patrick Uiterwijk from comment #7)
> Issues:
> - License is a very old one (Library GPL, which is superseded by Lesser GPL)

Fixed! (Updated to LGPLGv3+)

> - COPYING is not installed

Fixed!

> - Using both %-style macros and $-style variables

Fixed!

> - Package contains a lot of files that don't currenlty conflict, but sound
>   like they will very likely conflict easily

This was a misunderstanding. Should be fine.

> - Hardcoded paths used (%_prefix}/lib vs %{_libdir})

Fixed!

> - No %build section

Fixed!

> - No documentation

Fixed!

> Rpmlint
> -------
> Checking: atomic-devmode-0.1-1.fc21.x86_64.rpm
>           atomic-devmode-0.1-1.fc21.src.rpm
> atomic-devmode.x86_64: E: explicit-lib-dependency libpwquality

This is an issue with the libpwquality package, which contains the /usr/bin/pwmake binary, which my scripts require.

> atomic-devmode.x86_64: E: no-binary

Fixed!

> atomic-devmode.x86_64: W: only-non-binary-in-usr-lib

Fixed!

> atomic-devmode.x86_64: W: no-documentation

Fixed!

> atomic-devmode.src: W: spelling-error %description -l en_US init -> unit,
> int, nit

Not a typo. The name of the package mentioned is "cloud-init".

> atomic-devmode.src:32: E: hardcoded-library-path in
> %{_prefix}/lib/atomic-devmode

Fixed!

> atomic-devmode.src: W: no-%build-section

Fixed!

> atomic-devmode.src: W: invalid-url Source0: atomic-devmode.tar.gz

I provide instructions right above this line for how to obtain the archive:

---
# From `make archive REF=v${VERSION}`
---

(In reply to Patrick Uiterwijk from comment #8)
> Oh, and you should mark the package as noarch probably, since I odn't think
> there's anything archful in there.

Done!
Comment 12 Patrick Uiterwijk 2016-01-14 16:15:44 EST
Thank you, the package looks good now, and is APPROVED.
Comment 13 Patrick Uiterwijk 2016-01-14 18:13:34 EST
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/atomic-devmode
Comment 14 Jonathan Lebon 2016-01-14 20:12:46 EST
Thanks Patrick for taking the time to review this request.
Comment 15 Mike McCune 2016-03-28 19:23:30 EDT
This bug was accidentally moved from POST to MODIFIED via an error in automation, please see mmccune@redhat.com with any questions
Comment 16 Parag AN(पराग) 2016-07-13 13:27:53 EDT
I see this package in F24+ repository at least.

Note You need to log in before you can comment on or make changes to this bug.